package divcon;

import java.io.*;
import java.util.*;
/* ========================================================================================== */ /**
  @wt@CE擾邽߂̃NXB<p>
  @擾ɂẮAt@CeĚƁAe̓ǂݎ肪sB̌ʂƁAǂݎ
  éA get ñ\bhŎ擾oB<p>
*/
public class DetectInfFile
  extends InfFile {
  // -----------------------------------------------------------------------------------------------
  // eϐQ

  private int errorCode; // G[R[h
    /** G[B */
    public static final int ERR_NONE = 0;
    /** RXgN^Ɏw肳ꂽt@Cǂ߂ȂB */
    public static final int ERR_CANNOT_READ = 1;
    /** RXgN^Ɏw肳ꂽt@CfBNgł鎖B */
    public static final int ERR_DIRECTORY = 2;
    /** RXgN^Ɏw肳ꂽwt@C̓eĂ鎖B */
    public static final int ERR_BAD_FORMAT = 3;
    /** RXgN^Ɏw肳ꂽwt@C̓eɂt@C byte TCYĂ鎖B */
    public static final int ERR_BAD_FILESIZE = 4;

  private File infFile; // wt@C

  private boolean usable; // Ó\

  private boolean srcFileInfExist; // t@C̗L
  private FileInf srcFileInf; // t@C
  private boolean divNumberExist; // ̗L
  private long    divNumber; // 
  private long    divFileCnt; // t@CJE^
  private ArrayList<FileInf> divFileInfs; // t@C

  /* ---------------------------------------------------------------------------------------- */ /**
    @wt@C̃t@C󂯎Awt@CǂݎEE߂A̓el
    tB[hɐݒ肷B<p>
    @param f wt@C̃t@C
  */
  public DetectInfFile(
    File f
  ) {
    // K{̏
    usable = false; // ŏ͔Ó
    errorCode = ERR_NONE;
    srcFileInfExist = false;
    divNumberExist = false;
    infFile = new File( f.toString() );

    // {̃`FbN
    if ( infFile.isDirectory() == true ) { // fBNgł͂Ȃ
      errorCode = ERR_DIRECTORY;
      return;
    }
    if ( infFile.canRead() == false ) { // ǂ߂t@C
      errorCode = ERR_CANNOT_READ;
      return;
    }

    // ǂݍ݂̂߂̏
    srcFileInf = new FileInf();
    divNumber = 0;
    divFileCnt = 0;
    divFileInfs = new ArrayList<FileInf>();
    String s = new String(); // wt@C̓ePsi[邽߂̕

    // ǂݍݏ
    try {
      BufferedReader inputFile = new BufferedReader( new FileReader( infFile.toString() ) );
      while ( null != ( s = inputFile.readLine() ) ) { // wt@C̑SĂ̍sǂ
        s = Common.removeComment( s ); // Rg𔲂
        if ( s.length() > 0 ) { // Rg𔲂ʁA󕶎ɂȂĂ܂΂
          if ( true != detectOneLine( s ) ) { // Ps
            errorCode = ERR_BAD_FORMAT;
            inputFile.close();
            return;
          }
        }
      }
      inputFile.close();
    }
    catch ( Exception e ) {
      errorCode = ERR_CANNOT_READ;
      return;
    }

    // 낢ƌʂ`FbN
    if ( srcFileInfExist != true || divNumberExist != true ) { // ׂ͂邩
      errorCode = ERR_BAD_FORMAT;
      return;
    }
    if ( divNumber < 1 ) { // ͂Pȏォ
      errorCode = ERR_BAD_FORMAT;
      return;
    }
    if ( divNumber != divFileCnt ) { // t@ČɐHႢ͖
      errorCode = ERR_BAD_FORMAT;
      return;
    }
    int total = 0; // et@C̍vTCY
    for ( FileInf fi:divFileInfs ) { // vTCYZo
      total += fi.getSize();
    }
    if ( total != srcFileInf.getSize() ) { // et@C̍vTCYƕt@CTCY͓
      errorCode = ERR_BAD_FILESIZE;
      return;
    }

    // ܂ŗĂ͂߂đÓƌ
    usable = true;
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^X̓eÓ擾B<p>
    @return Ół trueAÓłȂ falseB<p>
  */
  public boolean isUsable(
  ) {
    // G[΂͂Ół͂Ȃ
    if ( errorCode != ERR_NONE ) {
      usable = false;
    }
    return usable;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^X̃G[R[h擾B<p>
    @return tB[h̃G[R[hQƁB
  */
  public int getErrorCode(
  ) {
    return errorCode;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@C̏擾B<p>
    @return null łȂ΁At@C̏񂪕ԂĂBnull ȂΕԂĂȂB
  */
  public FileInf getSrcFileInf(
  ) {
    if ( this.isUsable() != true ) {
      return null;
    }
    FileInf fi = new FileInf( srcFileInf.getName(), srcFileInf.getSize(), srcFileInf.getCrcValue() );
    return fi;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @擾B<p>
    @return ŕԂBȂԂĂȂB
  */
  public long getDivNumber(
  ) {
    if ( this.isUsable() != true ) {
      return -1;
    }
    return divNumber;
  }


  /* ---------------------------------------------------------------------------------------- */ /**
    @et@C̏擾B<p>
    @return null łȂ΁Aet@C̏񂪕ԂĂBnull ȂΕԂĂȂB
  */
  public ArrayList<FileInf> getDivFileInfs(
  ) {
    if ( this.isUsable() != true ) {
      return null;
    }
    if ( divFileInfs.size() == 0 ) {
      return null;
    }

    ArrayList<FileInf> fis = new ArrayList<FileInf>( divFileInfs.size() );
    for ( FileInf fi:divFileInfs ) {
      fis.add( new FileInf( fi.getName(), fi.getSize(), fi.getCrcValue() ) );
    }
    return fis;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @wt@CeLXgt@CƂĂPsǂݍ񂾁ÂPsɂČAÓȓe
    ł΂ǂݎARׂtB[hɐݒ肷B<p>
    @param s ׂs̓e
    @return Ȃ trueAsȂ false
  */
  private boolean detectOneLine(
    String s
  ) {
    s = Common.skipSpace( s );
    // wb_ƈv
    if ( true == Common.compareStringsHead( HEADER, s ) ) {
      return true;
    }

    // "SrcFile" ƈv
    if ( true == Common.compareStringsHead( SRCFILE, s ) ) {
      if ( srcFileInfExist == true ) { // QLĂ͂Ȃ
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( SRCFILE.length() );
      s = Common.skipSpace( s );
      // "SrcFile" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎͌ʂ̃t@C
      FileInf fi = new FileInf();
      if ( true != detectOneFileInf( s, fi ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      srcFileInf.setName( fi.getName() );
      srcFileInf.setSize( fi.getSize() );
      srcFileInf.setCrcValue( fi.getCrcValue() );
      srcFileInfExist = true; // LLɐݒ
      return true;
    }

    // "DivNumber" ƈv
    if ( true == Common.compareStringsHead( DIVNUMBER, s ) ) {
      if ( divNumberExist == true ) { // QLĂ͂Ȃ
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( DIVNUMBER.length() );
      s = Common.skipSpace( s );
      // "DivNumber" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎͐
      String divn = Common.getNumbersOnly( s );
      if ( divn.length() == 0 ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( divn.length() );
      s = Common.skipSpace( s );
      // ̎͏I[L ";"
      if ( true != Common.compareStringsHead( TERMINATOR, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      // 𐔒lɕϊ
      divNumber = Common.longFromString( divn );
      divNumberExist = true; // LLɐݒ
      return true;
    }

    // "DivFile" ƈv
    if ( true == Common.compareStringsHead( DIVFILE, s ) ) {
      if ( divNumberExist == false ) { // ł divNumber ͖΂ȂȂ
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      if ( divFileCnt >= divNumber ) { // divNumber 葽LĂ͂ȂȂ
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( DIVFILE.length() );
      s = Common.skipSpace( s );
      // "DivFile" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎͌ʂ̃t@C
      FileInf fi = new FileInf();
      if ( true != detectOneFileInf( s, fi ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      divFileInfs.add( fi );
      divFileCnt ++; // JEgZ
      return true;
    }

    // Encrypted ƈv #### 1.0 łł͖

    // ̗vfLĂĐ
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @Pt@C̃t@C񕶎A^ꂽt@CɊi[B<p>
    @param s t@C񂪊i[ĂƊ҂镶B
    @param fi ʂi[ׂt@CB
    @return Ei[ trueAȂ falseB
  */
  private boolean detectOneFileInf(
    String  s,
    FileInf fi
  ) {
    String name;
    String sizeStr;
    String crcStr;

    s = Common.skipSpace( s );
    // "{" n܂
    if ( true != Common.compareStringsHead( BEGIN, s ) ) {
      errorCode = ERR_BAD_FORMAT;
      return false;
    }
    s = s.substring( BEGIN.length() );
    s = Common.skipSpace( s );
    // "{" ̎ Name="...";
      // "Name"
      if ( true != Common.compareStringsHead( FILE_NAME, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( FILE_NAME.length() );
      s = Common.skipSpace( s );
      // "Name" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎ "\""
      if ( true != Common.compareStringsHead( QUOTE, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( QUOTE.length() ); // ̒ Common.skipSpace() ͕sv
      // "\"" ̒́A "\"" ܂ŕ
      name = Common.getUntilQuote( s, QUOTE );
      if ( name.length() == 0 ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( name.length() ); // ̒ Common.skipSpace() ͕sv
      // ̒ "\""
      if ( true != Common.compareStringsHead( QUOTE, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( QUOTE.length() );
      s = Common.skipSpace( s );
      // "\"" ͍̎ڏI[L ";"
      if ( true != Common.compareStringsHead( TERMINATOR, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( TERMINATOR.length() );
      s = Common.skipSpace( s );

    // "Name="...";" ̎ "Size=...;"
      // "Size"
      if ( true != Common.compareStringsHead( FILE_SIZE, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( FILE_SIZE.length() );
      s = Common.skipSpace( s );
      // "Size" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎͐
      sizeStr = Common.getNumbersOnly( s );
      if ( sizeStr.length() == 0 ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( sizeStr.length() );
      s = Common.skipSpace( s );
      // ͍̎ڏI[L ";"
      if ( true != Common.compareStringsHead( TERMINATOR, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( TERMINATOR.length() );
      s = Common.skipSpace( s );

    // "Size=;" ̎ "CRC=0x...;"
      // "CRC"
      if ( true != Common.compareStringsHead( FILE_CRC, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( FILE_CRC.length() );
      s = Common.skipSpace( s );
      // "CRC" ̎ "="
      if ( true != Common.compareStringsHead( EQUAL, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( EQUAL.length() );
      s = Common.skipSpace( s );
      // "=" ̎ "0x"  "0X"
      if ( true != Common.compareStringsHead( "0x", s ) ) {
        if ( true != Common.compareStringsHead( "0X", s ) ) {
          errorCode = ERR_BAD_FORMAT;
          return false;
        }
      }
      s = s.substring( 2 ); // ̒ Common.skipSpace() ͕sv
      // "0x" ̎͂PUi
      crcStr = Common.getHexsOnly( s );
      if ( crcStr.length() == 0 ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( crcStr.length() );
      s = Common.skipSpace( s );
      // PUi͍̎ڏI[L ";"
      if ( true != Common.compareStringsHead( TERMINATOR, s ) ) {
        errorCode = ERR_BAD_FORMAT;
        return false;
      }
      s = s.substring( TERMINATOR.length() );
      s = Common.skipSpace( s );

    // "}" ŏI
    if ( true != Common.compareStringsHead( END, s ) ) {
      errorCode = ERR_BAD_FORMAT;
      return false;
    }
    s = s.substring( END.length() );
    s = Common.skipSpace( s );
    // s[ƂďI[L ";"
    if ( true != Common.compareStringsHead( TERMINATOR, s ) ) {
      errorCode = ERR_BAD_FORMAT;
      return false;
    }

    // ܂ŗāA͂߂ăt@CPɂđÓƌ̂ŁAeڂɐݒ肷
    fi.setName( name );
    fi.setSize( Common.longFromString( sizeStr ) );
    fi.setCrcValue( Common.longFromHexString( crcStr ) );
    return true;
  }

}
// ================================================================================================
// I
