package divcon;

import java.io.*;
import java.util.*;
import javax.swing.*;
/* ========================================================================================== */ /**
  @t@C@\NXB<p>
*/
public class ExecConFile {

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@CɕKvȏ󂯎AsB<p>
    @param parentPane eyCA_CAObZ[Ŵ߂ɕKv
    @param readDir ꏊipX݂̂̏ꍇƁAt@Ct̏ꍇƂj
    @param writeDir ꏊipX݂̂̏ꍇƁAt@Ct̏ꍇƂj
    @param srcDivFileInfs et@C
  */
  public ExecConFile(
    MainForm      parentPane,
    File          readDir,
    File          writeDir,
    DetectInfFile srcDivFileInfs
  ) {
    FileInf            srcFileInf; // Ǒt@C
    ArrayList<FileInf> divFileInfs; // et@C̏
    FileInputStream    inputStream; // ̓t@Ciet@Cj
    FileOutputStream   outputStream; // o̓t@Cit@Cj
    String readDirStr; // iǂݎjꏊ
    String writeDirStr; // i݁jꏊ
    String readFullPathName; // et@ĆAtpX܂ރt@C
    long fileCnt; // t@C̃JE^
    long crcValue; // CRC lp[NGA
    long totalSize; // et@C̍v byte TCY
    long byteCnt; // et@CP byte TCYp[N
    int  fileByte; // byte Pʂ̃t@Ce

    // nꂽ񂪎g邩ǂ`FbN
    if ( srcDivFileInfs.isUsable() != true ) {
      JOptionPane.showMessageDialog( parentPane, "wt@C̏ɃG[܂", "G[", JOptionPane.ERROR_MESSAGE );
      return;
    }
    if ( srcDivFileInfs.getDivNumber() < 2 ) {
      JOptionPane.showMessageDialog( parentPane, "wt@C̓eɃG[܂", "G[", JOptionPane.ERROR_MESSAGE );
      return;
    }

    // ǂݍ݁AopfBNg̃fBNĝ݂o
    readDirStr = Common.getDirNameOnly( readDir );
    writeDirStr = Common.getDirNameOnly( writeDir );
    // t@CAet@C̃t@Co
    srcFileInf = srcDivFileInfs.getSrcFileInf();
    divFileInfs = srcDivFileInfs.getDivFileInfs();

    fileCnt = 0L;
    totalSize = 0L;
    try {
      outputStream = new FileOutputStream( writeDirStr + File.separator + srcFileInf.getName() ); // o̓t@CI[v
      // [v
      for ( fileCnt = 1; fileCnt <= srcDivFileInfs.getDivNumber(); fileCnt ++ ) {
        parentPane.setSttBar( "ł ... " + fileCnt + "ځ^" + srcDivFileInfs.getDivNumber() + "" ); // Xe[^Xo[ɐi\
        readFullPathName = new String( readDirStr + File.separator + divFileInfs.get( ( int )fileCnt - 1 ).getName() );
        // CRC `FbN
        crcValue = Common.getFileCrcValue( new File( readFullPathName ) );
        if ( crcValue != divFileInfs.get( ( int )fileCnt - 1 ).getCrcValue() ) {
          parentPane.setSttBar( "t@C CRC G[" );
          JOptionPane.showMessageDialog( parentPane, "t@C " + fileCnt + " \n'" + divFileInfs.get( ( int )fileCnt - 1 ).getName() + "'\n CRC v܂", "G[", JOptionPane.ERROR_MESSAGE );
          outputStream.close();
          return;
        }
        // ̓t@Cit@CjPo̓t@Cit@CjɃRs[
        inputStream = new FileInputStream( readFullPathName ); // ̓t@CI[v
        byteCnt = 0L;
        while( ( byteCnt < divFileInfs.get( ( int )fileCnt - 1 ).getSize() ) && ( ( fileByte = inputStream.read() ) != -1 ) ) {
          outputStream.write( fileByte );
          byteCnt ++;
        }
        totalSize += byteCnt;
        inputStream.close(); // ̓t@CN[Y
      }
      outputStream.close(); // o̓t@CN[Y
    }
    catch ( Exception e ) {
      parentPane.setSttBar( "t@CG[" );
      JOptionPane.showMessageDialog( parentPane, "t@Cɖ肪܂\nt@C " + fileCnt + " ", "G[", JOptionPane.ERROR_MESSAGE );
      return;
    }

    // TCỸ`FbN
    if ( totalSize != srcFileInf.getSize() ) {
      JOptionPane.showMessageDialog( parentPane, "t@C̃TCYAÕTCYƈvĂ܂񂪁A͊܂", "x", JOptionPane.WARNING_MESSAGE );
    }
    //  CRC ̃`FbN
    crcValue = Common.getFileCrcValue( new File( writeDirStr + File.separator + srcFileInf.getName() ) );
    if ( crcValue != srcFileInf.getCrcValue() ) {
      JOptionPane.showMessageDialog( parentPane, "t@C CRC AO CRC ƈvĂ܂񂪁A͊܂", "x", JOptionPane.WARNING_MESSAGE );
    }

    parentPane.setSttBar( "I܂" ); // Xe[^Xo[ɐi\

    // t@C̏_CAOŕ\
    JOptionPane.showMessageDialog( parentPane, "I܂I L̃t@C𐶐܂\n" + writeDirStr + File.separator + srcFileInf.getName(), "ʒm", JOptionPane.INFORMATION_MESSAGE );
    return;
  }

}
// =================================================================================================
// I
