package divcon;

import java.io.*;
import java.util.*;
import javax.swing.*;
/* ========================================================================================== */ /**
  @t@C@\NXB<p>
*/
public class ExecDivFile
  extends InfFile {

  // -----------------------------------------------------------------------------------------------
  // G[ltB[h
  /** G[ */
  public static final int ERR_NONE = 0;
  /** ǂݍ߂Ȃt@C */
  public static final int ERR_CANNOT_READ = 1;
  /** TCYsl */
  public static final int ERR_ILLEGAL_DIVSIZE = 2;
  /** sl */
  public static final int ERR_ILLEGAL_DIVNUMBER = 3;
  /** 悪s */
  public static final int ERR_ILLEGAL_DIVOBJDIR = 4;

  // -----------------------------------------------------------------------------------------------
  // tB[h

  private int errorCode;

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@CɕKvȏ󂯎AsB<p>
    @param parentPane eyCA_CAObZ[Ŵ߂ɕKv
    @param srcFileFullPathName t@CitpXAt@Ctj
    @param isSize TCYȂ trueAȂ false
    @param val TCYȂ番 byte TCYAȂ
    @param objDirFullPathName pXitpXAt@Ctj
  */
  public ExecDivFile(
    MainForm parentPane,
    File     srcFileFullPathName,
    boolean  isSize,
    long     val,
    File     objDirFullPathName
  ) {
    boolean      ret; // _~[
    File         objPath;

    // K{̏
    errorCode = ERR_NONE;

    // 󂯎p[^̃`FbN
      // t@C̃`FbN
      if ( srcFileFullPathName.canRead() != true ) {
        JOptionPane.showMessageDialog( parentPane, "t@Cǂݎ܂", "x", JOptionPane.WARNING_MESSAGE );
        errorCode = ERR_CANNOT_READ;
        return;
      }
      // @ɂ`FbN
      if ( isSize ) {
        // TCY 1 Ȃsl
        if ( val < 1 ) {
          JOptionPane.showMessageDialog( parentPane, "TCYsł", "x", JOptionPane.WARNING_MESSAGE );
          errorCode = ERR_ILLEGAL_DIVSIZE;
          return;
        }
        // TCYt@CTCYȏȂ番Ȃ
        if ( val >= srcFileFullPathName.length() ) {
          JOptionPane.showMessageDialog( parentPane, "w̕TCYt@Cȏ̂ߕ܂", "ʒm", JOptionPane.INFORMATION_MESSAGE );
          return;
        }
      }
      else {
        //  1 ȉȂ番Ȃ
        if ( val <= 1 ) {
          JOptionPane.showMessageDialog( parentPane, " 1 ȉ̂ߕ܂", "ʒm", JOptionPane.INFORMATION_MESSAGE );
          return;
        }
        // t@CTCY𒴂Ȃsl
        if ( val > srcFileFullPathName.length() ) {
          JOptionPane.showMessageDialog( parentPane, "傫܂", "x", JOptionPane.WARNING_MESSAGE );
          errorCode = ERR_ILLEGAL_DIVNUMBER;
          return;
        }
      }
      // ̃`FbN
      if ( objDirFullPathName.exists() != true ) {
        JOptionPane.showMessageDialog( parentPane, "悪݂܂", "x", JOptionPane.WARNING_MESSAGE );
        errorCode = ERR_ILLEGAL_DIVOBJDIR;
        return;
      }

    // t@C̕pX𓾂
    objPath = new File( Common.getDirNameOnly( objDirFullPathName ) );

    // 상\bhN
    if ( isSize ) {
      ret = execDivFileAsSize( parentPane, srcFileFullPathName, val, objPath );
    }
    else {
      ret = execDivFileAsNumber( parentPane, srcFileFullPathName, val, objPath );
    }

    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^X̎G[R[h擾B<p>
    @return G[R[hBERR_ Ŏn܂tB[hlQƂ̎B<p>
  */
  public int getErrorCode(
  ) {
    return errorCode;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @TCYɂt@C𕪊Awt@C𐶐B<p>
    @param parentPane eyC
    @param srcFileFullPathName t@CitpXAt@Ctj
    @param divSize  byte TCYit@CTCY菬Ȃ΂ȂȂj
    @param objFullPath fBNgitpXAt@Cj
    @return Ȃ trueAsȂ falseB<p>
  */
  private boolean execDivFileAsSize(
    MainForm parentPane,
    File    srcFileFullPathName,
    long    divSize,
    File    objFullPath
  ) {
    long divn; // 
    long divls; // ŏIt@CTCY

    if ( divSize >= srcFileFullPathName.length() ) {
      return false;
    }

    // divn == 1 Ȃ divls == divSize == srcFileFullPathName.length()
    // divn > 1  divn * divSize == srcFileFullPathName.length() Ȃ divls == divSize
    // divn > 1  divn * divSize > srcFileFullPathName.length() Ȃ divls != divSize  ( divn - 1 ) * divSize + divls == srcFileFullPathName.length()
    // ܂A ( divn - 1 ) * divSize + divls == srcFileFullPathName.length() 藧悤ɎZo

    divn = ( long )( srcFileFullPathName.length() / divSize ); // Ƃ 20 / 7 Ȃ炱̎_ divn  2
    if ( srcFileFullPathName.length() % divSize > 0 ) { // Ƃ 20 % 7  > 0 Ȃ̂ŁAs divn  3 ƂȂ
      divn ++;
    }
    // ȏ divn ͕K 2 ȏ̒lƂČ肳
    divls = srcFileFullPathName.length() - ( divn - 1 ) * divSize; // `ʂɎZo

    return execDivFile( parentPane, srcFileFullPathName, divn, divSize, divls, objFullPath );
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @ɂt@C𕪊Awt@C𐶐B<p>
    @param parentPane eyC
    @param srcFileFullPathName t@CitpXAt@Ctj
    @param divNum iQȏłȂ΂ȂȂj
    @param objFullPath fBNgitpXAt@Cj
    @return Ȃ trueAsȂ falseB<p>
  */
  private boolean execDivFileAsNumber(
    MainForm parentPane,
    File     srcFileFullPathName,
    long     divNum,
    File     objFullPath
  ) {
    long divs; // TCY
    long divls; // ŏITCY

    if ( divNum > srcFileFullPathName.length() || divNum < 2 ) {
      return false;
    }

    // divNum == 1 Ȃ divls == divs == srcFileFullPathName.length()
    // divNum > 1  divNum * divs == srcFileFullPathName.length() Ȃ divls == divs
    // divNum > 1  divNum * divs > srcFileFullPathName.length() Ȃ divls != divs  ( divNum - 1 ) * divs + divls == srcFileFullPathName.length()
    // ܂A ( divNum - 1 ) * divs + divls == srcFileFullPathName.length() 藧悤ɎZo

    // TCYZo
    divs = srcFileFullPathName.length() / divNum; // Ƃ 20 / 3 Ȃ divs  6A10 / 9 Ȃ divs  1
    divls = srcFileFullPathName.length() - ( divNum - 1 ) * divs; // `ʂɎZo

    return execDivFile( parentPane, srcFileFullPathName, divNum, divs, divls, objFullPath );
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@C𕪊Awt@C𐶐B<p>
    @param parentPane eyC
    @param srcFileFullPathName t@CitpXAt@Ctj
    @param divNumber iQȏłȂ΂ȂȂj
    @param divSize  byte TCYit@CTCY菬Ȃ΂ȂȂj
    @param divLastSize ŏI byte TCYit@CTCY菬Ȃ΂ȂȂj
    @param objFullPath fBNgitpXAt@Cj
    @return Ȃ trueAsȂ falseB<p>
  */
  private boolean execDivFile(
    MainForm parentPane,
    File     srcFileFullPathName,
    long     divNumber,
    long     divSize,
    long     divLastSize,
    File     objFullPath
  ) {
    String fileNameBase; // x[XƂȂt@C
    String divFileName; // t@CiAԕtj
    String divFileExtension; // t@Cɕtgq
    String divFileFullPathName; // t@C

    FileInputStream  inputStream; // ̓t@Cit@Cj
    FileOutputStream outputStream; // o̓t@Cit@Cj

    FileInf srcFileInf; // t@C
    ArrayList<FileInf> divFileInfs; // t@C

    int fileCnt = 0; // t@Č
    int byteCnt; //  byte 
    int fileByte; // byte Pʂ̃t@Ce

    // ܂̓`FbN
    if ( divNumber < 2 || divSize >= srcFileFullPathName.length() || divLastSize >= srcFileFullPathName.length() ) {
      parentPane.setSttBar( "t@CvOG[" );
      JOptionPane.showMessageDialog( parentPane, "t@CɃvOG[܂", "G[", JOptionPane.ERROR_MESSAGE );
      return false;
    }

    // t@C̃t@Ĉ݂邽߂̑O
    String s = new String( srcFileFullPathName.toString() );
    int p = s.lastIndexOf( File.separator ); // Ō̃fBNg؂L̈ʒu
    fileNameBase = new String( s.substring( p + 1 ) ); // Ńt@CiƊgqĵ݂oꂽ

    // t@C̃t@C
    srcFileInf = new FileInf();
    long srcCrc = Common.getFileCrcValue( srcFileFullPathName );
    if ( srcCrc < 0 ) {
      parentPane.setSttBar( "t@C CRC ZoG[" );
      JOptionPane.showMessageDialog( parentPane, "t@C CRC ZoɃvOG[܂", "G[", JOptionPane.ERROR_MESSAGE );
      return false;
    }
    srcFileInf.setFileInf( fileNameBase, srcFileFullPathName.length(), srcCrc ); // t@C̃t@Cɂ̓pXi[Ȃ̂ fileNameBase p

    // et@C̃t@C
    divFileInfs = new ArrayList<FileInf>();

    // t@C
    try {
      inputStream = new FileInputStream( srcFileFullPathName.toString() ); // ̓t@CI[v
      // t@Co͂AP񏭂Ȃ[vŁiŌ̂P divLastSize TCỸt@C˂΂ȂȂj
      for ( fileCnt = 1; fileCnt < divNumber; fileCnt ++ ) { // P񏭂Ȃ[vɂ邽߁Afilecnt <= divNumber ɂ͂Ȃ
        parentPane.setSttBar( "ł ... " + fileCnt + "ځ^" + divNumber + "" ); // Xe[^Xo[ɐi\
        divFileName = makeDivFileName( fileNameBase, fileCnt, divNumber );
        divFileFullPathName = new String( objFullPath.toString() + File.separator + divFileName );
        outputStream = new FileOutputStream( divFileFullPathName ); // o̓t@CI[v
        byteCnt = 0;
        // divSize Rs[
        while( ( byteCnt < divSize ) && ( ( fileByte = inputStream.read() ) != -1 ) ) {
          outputStream.write( fileByte );
          byteCnt ++;
        }
        outputStream.close(); // o̓t@CN[Y
        // et@C̃t@C
        long divCrc = Common.getFileCrcValue( divFileFullPathName );
        if ( divCrc < 0 ) {
          parentPane.setSttBar( "t@C CRC ZoG[" );
          JOptionPane.showMessageDialog( parentPane, "t@C " + fileCnt + "ڂ CRC ZoɃvOG[܂", "G[", JOptionPane.ERROR_MESSAGE );
          inputStream.close();
          outputStream.close();
          return false;
        }
        divFileInfs.add( new FileInf( divFileName, divSize, divCrc ) );
      }
      // ŏIt@Co͂
      {
        parentPane.setSttBar( "ł ... " + fileCnt + "ځ^" + divNumber + "" ); // Xe[^Xo[ɐi\
        divFileName = makeDivFileName( fileNameBase, fileCnt, divNumber );
        divFileFullPathName = new String( objFullPath.toString() + File.separator + divFileName );
        outputStream = new FileOutputStream( divFileFullPathName ); // o̓t@CI[v
        byteCnt = 0;
        // divLastSize Rs[
        while( ( byteCnt < divLastSize ) && ( ( fileByte = inputStream.read() ) != -1 ) ) {
          outputStream.write( fileByte );
          byteCnt ++;
        }
        outputStream.close(); // o̓t@CN[Y
        // ŏIt@C̃t@C
        long divCrc = Common.getFileCrcValue( divFileFullPathName );
        if ( divCrc < 0 ) {
          parentPane.setSttBar( "t@CG[" );
          JOptionPane.showMessageDialog( parentPane, "t@C " + fileCnt + "ڂ CRC ZoɃvOG[܂", "G[", JOptionPane.ERROR_MESSAGE );
          inputStream.close();
          outputStream.close();
          return false;
        }
        divFileInfs.add( new FileInf( divFileName, divLastSize, divCrc ) );
      }
      inputStream.close(); // ̓t@CN[Y
    }
    catch ( Exception e ) {
      parentPane.setSttBar( "t@CG[" );
      JOptionPane.showMessageDialog( parentPane, "t@Cɖ肪܂\n " + fileCnt + " ", "G[", JOptionPane.ERROR_MESSAGE );
      return false;
    }

    // wt@C쐬
    parentPane.setSttBar( "wt@C쐬ł" ); // Xe[^Xo[ɐi\
    if ( makeDivInfFile( parentPane, objFullPath.toString(), fileNameBase, srcFileInf, fileCnt, divFileInfs ) != true ) {
      parentPane.setSttBar( "wt@C쐬G[" );
      JOptionPane.showMessageDialog( parentPane, "wt@C쐬ɖ肪܂\nAet@C͐Ă܂", "G[", JOptionPane.ERROR_MESSAGE );
      return false;
    }
    parentPane.setSttBar( "I܂" ); // Xe[^Xo[ɐi\

    // wt@C̏_CAOŕ\
    JOptionPane.showMessageDialog( parentPane, "I܂I L̕wt@C𐶐܂\n" + objFullPath.toString() + File.separator + fileNameBase + EXTENSION, "ʒm", JOptionPane.INFORMATION_MESSAGE );
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @wt@C𐶐B<p>
    @param parentPane eyC
    @param objFullPath fBNgitpXAt@Cj
    @param objFileName t@CipXj
    @param srcFileInf t@C
    @param divNumber 
    @param divFileInfs et@C
    @return Ȃ trueAsȂ falseB<p>
  */
  private boolean makeDivInfFile(
    MainForm           parentPane,
    String             objFullPath,
    String             objFileName,
    FileInf            srcFileInf,
    long               divNumber,
    ArrayList<FileInf> divFileInfs
  ) {
    try {
      PrintWriter pw = new PrintWriter( new String( objFullPath + File.separator + objFileName + EXTENSION ) );
      pw.println( HEADER + " " + Common.VERS + TERMINATOR );
      pw.println( SRCFILE + EQUAL + makeWriteLineImageInfFile( srcFileInf ) + TERMINATOR );
      pw.println( DIVNUMBER + EQUAL + ( "" + divNumber ) + TERMINATOR );
      for ( long i = 0; i < divNumber; i ++ ) {
        pw.println( DIVFILE + EQUAL + makeWriteLineImageInfFile( divFileInfs.get( ( int )i ) ) + TERMINATOR );
      }
      pw.close();
      return true;
    }
    catch ( Exception e ) {
      JOptionPane.showMessageDialog( parentPane, "wt@C̍쐬o܂\n" + objFullPath + File.separator + objFileName + EXTENSION, "G[", JOptionPane.ERROR_MESSAGE );
      parentPane.setSttBar( "wt@C쐬G[" );
      return false;
    }
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@CipXEAԕtj𐶐B<p>
    @param objFileName t@CipXj
    @param divAllNumber S
    @param divNumber t@Cԍ
    @return Ȃt@CAsȂ nullB<p>
  */
  private String makeDivFileName(
    String objFileName,
    long   divAllNumber,
    long   divNumber
  ) {
    return new String( objFileName + EXTENSION + Common.fixMinWidthStringFromLong( divAllNumber, divNumber ) );
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @Pt@C FileInf \镪wt@CݗpC[W𐶐B<p>
    @param fi t@C
    @return Ȃ`ݗpC[WAsȂ nullB<p>
  */
  private String makeWriteLineImageInfFile(
    FileInf fi
  ) {
    StringBuffer sb = new StringBuffer( "" );
    sb.append( BEGIN );
    sb.append( " " + FILE_NAME + EQUAL + QUOTE + fi.getName() + QUOTE + TERMINATOR );
    sb.append( " " + FILE_SIZE + EQUAL + fi.getSize() + TERMINATOR );
    sb.append( " " + FILE_CRC  + EQUAL + "0x" + Common.hex8FromLong( fi.getCrcValue() ) + TERMINATOR );
    sb.append( " " + END );
    return new String( sb.toString() );
  }
}
// =================================================================================================
// I
