package divcon;
/* ========================================================================================== */ /**
  @t@C̏ێNXB<p>
  @t@CAt@C byte TCYAt@C CRC32 lÂR̏ێ鎖oB<br>
  @܂AR̏́AꂼIɐݒ^ݒ̏ԂĂANX̎gp҂ݒ胁
  \bhpďݒ肵ȂAݒƂԂ̂܂܂ƂȂBݒ̂܂܁A擾\bh
  pĂAÓȒl͓ȂBisUsable() Ȃт get ړe\bh̐QƂ̂ƁB
  <p>
*/
public class FileInf {

  // -----------------------------------------------------------------------------------------------
  // JtB[h

  private boolean usable; // Ó

  private boolean nameExist;
  private String  name; // t@CipX܂܂Ȃj

  private boolean sizeExist;
  private long    size; // t@C byte TCY

  private boolean crcExist;
  private long    crcValue; // t@C CRC32 lAint ƕɂȂĂ܂ꍇA\ɕssȂ long Ƃ

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@CێCX^X𐶐B<p>
  */
  public FileInf(
  ) {
    usable = false;
    nameExist = false;
    sizeExist = false;
    crcExist = false;
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@CێCX^X𐶐A͒lŏB<p>
    @͒lɂĂ͕s{RXgN^͕sԋpȂ̂ŁA{RXgN^̎gp͐
    ȂBsetFileInf() \bh̎gp𐄏B<p>
    @param fname t@CApX܂܂Ȃi{RXgN^̓pX̕܂`FbNȂj
    @param fsize t@C byte TCY
    @param fcrc  t@C CRC32 l
  */
  public FileInf(
    String fname,
    long   fsize,
    long   fcrc
  ) {
    usable = false;
    nameExist = false;
    sizeExist = false;
    crcExist = false;

    setName( fname );
    setSize( fsize );
    setCrcValue( fcrc );
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^X̑ÓԂB<p>
    @t@CAt@C byte TCYAt@C CRC32 l̑SĂNXgp҂ɂݒ肳ƁAC
    X^X͑ÓƂȂB<p>
    @return ÓȂ trueAÓłȂ falseB
  */
  public boolean isUsable(
  ) {
    return usable;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^XɃt@CAt@C byte TCYAt@C CRC32 lݒ肷B<p>
    @param fname t@CApX܂܂Ȃi{\bh̓pX̕܂`FbNȂj
    @param fsize t@C byte TCY
    @param fcrc  t@C CRC32 l
    @return ݒ萬Ȃ trueAsȂ falseB
  */
  public boolean setFileInf(
    String fname,
    long   fsize,
    long   fcrc
  ) {
    if ( false == setName( fname ) ) {
      return false;
    }
    if ( false == setSize( fsize ) ) {
      return false;
    }
    if ( false == setCrcValue( fcrc ) ) {
      return false;
    }
    checkUsable(); //  checkUsable() ́Ausable  true ɂiL̗ɂ肻Ȃj
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^XɃt@Cݒ肷B<p>
    @󕶎ݒ肵悤ƂƎsB<p>
    @param fname t@CApX܂܂Ȃi{\bh̓pX̕܂`FbNȂj
    @return ݒ萬Ȃ trueAsȂ falseB
  */
  public boolean setName(
    String fname
  ) {
    if ( fname.length() == 0 ) {
      return false;
    }
    name = fname;
    nameExist = true;
    checkUsable();
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^XɃt@C byte TCYݒ肷B<p>
    @ݒ肵悤ƂƎsB<p>
    @param fsize t@C byte TCY
    @return ݒ萬Ȃ trueAsȂ falseB
  */
  public boolean setSize(
    long fsize
  ) {
    if ( fsize < 0 ) {
      return false;
    }
    size = fsize;
    sizeExist = true;
    checkUsable();
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^XɃt@C CRC32 lݒ肷B<p>
    @param fcrc t@C CRC32 l
  */
  public boolean setCrcValue(
    long fcrc
  ) {
    if ( fcrc < 0 ) {
      return false;
    }
    crcValue = fcrc;
    crcExist = true;
    checkUsable();
    return true;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^Xt@C𓾂B<p>
    @return t@CipX܂܂ȂjAݒ肳ĂȂ null ԂB
  */
  public String getName(
  ) {
    if ( nameExist == true ) {
      String s = new String( name );
      return s;
    }
    return null;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^Xt@C byte TCY𓾂B<p>
    @return t@C byte TCYAݒ肳ĂȂ -1 ԂB
  */
  public long getSize(
  ) {
    if ( sizeExist == true ) {
      return size;
    }
    return -1;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^Xt@C CRC32 l𓾂B<p>
    @return t@C CRC32A-1 łΐݒ肳ĂȂ^BisUsable() ŊmFoB
  */
  public long getCrcValue(
  ) {
    if ( crcExist == true ) {
      return crcValue;
    }
    return -1;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @CX^X̊etB[hWo͂ɕ\B<p>
  */
  public void printFileInf(
  ) {
    System.out.print( "  FileInf:" );
    if ( usable != true ) {
      System.out.println( " is unUsable" );
    }
    else {
      System.out.print( " .name:" + ( nameExist ? "'" + name + "'" : "(noExist)" ) );
      System.out.print( ", .size:" + ( sizeExist ? size : "(noExist)" ) );
      System.out.println( ", crc32:" + ( crcExist ? "0x" + Common.hex8FromLong( crcValue ) : "(noExist)" ) );
    }
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @Óݒ肷B<p>
  */
  private void checkUsable(
  ) {
    usable = nameExist && sizeExist && crcExist;
    return;
  }

}
// =================================================================================================
// I
