package divcon;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.*;
import java.awt.Graphics;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;
import javax.swing.TransferHandler;
/* ========================================================================================== */ /**
  @GUI @\NXBۂ̃t@CȂǂ́Aʂ̃NXgŎB<p>
*/
public class MainForm
  extends JFrame
  implements ActionListener {

  // -----------------------------------------------------------------------------------------------
  // Œl

  private static final int mySizeX = 454; // TCYl
  private static final int mySizeY = 512; // cTCYl

  // -----------------------------------------------------------------------------------------------
  // tH[eRg[

  // j[
  private JMenuBar menuBar;
    private JMenu menuFile; // t@C
      private JMenuItem menuFileExit; // I
    private JMenu menuDisp; // \
      private ArrayList<JMenuItem> menuDispEach; // bNAhtB[ύXp
    private JMenu menuHelp; // wv
      private JMenuItem menuHelpHelp; // wv
      private JMenuItem menuHelpVer; // o[W

  // ^u
  private JTabbedPane tab;

    // yC
    private JPanel divPane;
      // t@CwyC
      private JPanel divSrcFilePane;
        private JTextField divSrcFileName; // t@C
        private JButton    divSrcFileBtn; // t@CQƃ{^
      // @wyC
      private JPanel divMethodPane;
        private JPanel divMethodSizePane; // zup̃yC
          private JRadioButton divMethodSizeRbtn; // TCY
          private JLabel       divMethodSizeLbl;
          private NumberField  divMethodSize; // TCY
          private JLabel       divMethodSizeUnitLbl;
          private JComboBox    divMethodSizeUnit; // TCYP
        private JPanel divMethodNumberPane; // zup̃yC
          private JRadioButton divMethodNumberRbtn; // 
          private JLabel       divMethodNumberLbl;
          private NumberField  divMethodNumber; // 
        private ButtonGroup divMethodRbgrp; // WI{^O[v
      // wyC
      private JPanel divObjDirPane;
        private JPanel divObjDirPane1; // zup̃yC
          private JCheckBox  divObjDirCkbx; // t@Ct@CƓfBNgɒuǂ̑I
        private JPanel divObjDirPane2; // zup̃yC
          private JLabel     divObjDirLbl;
          private JTextField divObjDirName; // t@CzufBNg
          private JButton    divObjDirBtn; // fBNgQƃ{^
      // s{^
      private JButton divBtn;

    // yC
    private JPanel conPane;
      // wt@CwyC
      private JPanel conInfFilePane;
        private JTextField conInfFileName; // wt@C
        private JButton    conInfFileBtn; // t@CQƃ{^
      // t@C\yC
      private JPanel conDispInfFilePane;
        private JTextArea conDispInfFileTxt;
        private JLabel    conDispInfFileLbl;
        private JTable    conDispInfFileTbl;
          private MyTableModel conDispInfFileTblMdl;
          private String[]     conDispInfFileColumn = { "ԍ", "t@C", "t@CTCY (byte)", "CRC (16 i)" };
          private Object[][]   conDispInfFileValue = { { "", "", "", "" } };
      // wyC
      private JPanel conObjDirPane;
        private JPanel conObjDirPane1; // zup̃yC
          private JCheckBox  conObjDirCkbx; // t@C𕪊t@CƓfBNgɒuǂ̑I
        private JPanel conObjDirPane2; // zup̃yC
          private JLabel     conObjDirLbl;
          private JTextField conObjDirName; // t@CzufBNg
          private JButton    conObjDirBtn; // fBNgQƃ{^
      // s{^
      private JButton conBtn;

  // Xe[^Xo[
  private JPanel sttBarPane;
    private JLabel sttBarLbl;

  // -----------------------------------------------------------------------------------------------
  // _CAORg[

  private JFileChooser divSrcFileChooser; // t@CI
  private JFileChooser divObjDirChooser; // fBNgI
  private JFileChooser conInfFileChooser; // wt@CI
  private JFileChooser conObjDirChooser; // fBNgI

  // -----------------------------------------------------------------------------------------------
  // eϐQ

  private UIManager.LookAndFeelInfo[] LFInfo; // bNAhtB[
  private String defaultLF; // OS W̃bNAhtB[
  private ArrayList<String> eachLF; // X̃bNAhtB[

  private File srcFile; // t@C
  private File divObjDir; // fBNg
  private File infFile; // wt@C
  private File conObjDir; // fBNg

  // -----------------------------------------------------------------------------------------------
  // e@\NXQ

  private DispHelp      dispHelp; // wv\
  private ExecDivFile   execDivFile; // s
  private DetectInfFile detectInfFile; // wt@C擾
  private ExecConFile   execConFile; // s

  /* ---------------------------------------------------------------------------------------- */ /**
    @GUI CtH[`悵B<p>
  */
  public MainForm(
  ) {
    // JFrame ̂̐ݒ
    this.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE ); // ܂͏I@ݒ
    this.setTitle( Common.MYNAME ); // 
    this.setSize( new Dimension( mySizeX, mySizeY ) ); // TCY
    this.setLayout( new BorderLayout() ); // CAEg
    // @\Iɂ BoxLayout łǂ̂AOIɋ[Xe[^Xo[ɂ BorderLayout  SOUTH KĂ

    // R|[lg̐Ɣzu

      // j[
      menuBar = new JMenuBar();
      menuBar.setBorder( new BevelBorder( BevelBorder.RAISED ) );
        menuFile = new JMenu( "t@C(F)" );
        menuFile.setMnemonic( 'F' );
          menuFileExit = new JMenuItem( "I(X)" );
          menuFileExit.setMnemonic( 'X' );
          menuFileExit.addActionListener( this ); // ANVo^
        menuFile.add( menuFileExit );
      menuBar.add( menuFile );
        menuDisp = new JMenu( "\(V)" ); // bNAhtB[ύXp
        menuDisp.setMnemonic( 'V' );
      menuBar.add( menuDisp );
        menuHelp = new JMenu( "wv(H)" );
        menuHelp.setMnemonic( 'H' );
          menuHelpHelp = new JMenuItem( "wv(H)" );
          menuHelpHelp.setMnemonic( 'H' );
          menuHelpHelp.addActionListener( this ); // ANVo^
        menuHelp.add( menuHelpHelp );
          menuHelpVer = new JMenuItem( "o[W(V)" );
          menuHelpVer.setMnemonic( 'V' );
          menuHelpVer.addActionListener( this ); // ANVo^
        menuHelp.add( menuHelpVer );
      menuBar.add( menuHelp );
    // ȏj[o[ƂĒǉ
    this.setJMenuBar( menuBar );

      // ^u
      tab = new JTabbedPane();
      final Border blackLine = BorderFactory.createLineBorder( Color.black ); // e^uŋpʏ{[_[C

        // yC
        divPane = new JPanel();
        divPane.setLayout( new BoxLayout( divPane, BoxLayout.Y_AXIS ) );
          // t@CwyC
          divSrcFilePane = new JPanel();
          divSrcFilePane.setBorder( new TitledBorder( blackLine, "t@C̎w", TitledBorder.LEFT, TitledBorder.TOP ) );
          divSrcFilePane.setLayout( new FlowLayout( FlowLayout.LEFT ) );
            // t@C̈
            divSrcFileName = new JTextField();
            divSrcFileName.setEditable( false ); // Cӓ͂Ȃ
            divSrcFileName.setColumns( 30 );
          divSrcFilePane.add( divSrcFileName );
            // Qƃ{^
            divSrcFileBtn = new JButton( "Q" );
            divSrcFileBtn.addActionListener( this ); // ANVo^
          divSrcFilePane.add( divSrcFileBtn );
        divPane.add( divSrcFilePane );
          // @wyC
          divMethodPane = new JPanel();
          divMethodPane.setBorder( new TitledBorder( blackLine, "@̎w", TitledBorder.LEFT, TitledBorder.TOP ) );
          divMethodPane.setLayout( new BoxLayout( divMethodPane, BoxLayout.Y_AXIS ) );
            // TCYwzup̉ByC
            divMethodSizePane = new JPanel();
            divMethodSizePane.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // WI{^
              divMethodSizeRbtn = new JRadioButton( "TCYŕ", true );
              divMethodSizeRbtn.addActionListener( this );
            divMethodSizePane.add( divMethodSizeRbtn );
              divMethodSizeLbl = new JLabel( "TCY" );
            divMethodSizePane.add( divMethodSizeLbl );
              // TCYẅ
              divMethodSize = new NumberField();
              divMethodSize.setColumns( 10 );
              divMethodSizePane.add( divMethodSize );
              divMethodSizeUnitLbl = new JLabel( "P" );
            divMethodSizePane.add( divMethodSizeUnitLbl );
              // PʎwR{{bNX
              divMethodSizeUnit = new JComboBox();
              divMethodSizeUnit.addItem( "Kbytes" );
              divMethodSizeUnit.addItem( "Mbytes" );
              divMethodSizeUnit.addItem( "Gbytes" );
            divMethodSizePane.add( divMethodSizeUnit );
          divMethodPane.add( divMethodSizePane );
            // wzup̉ByC
            divMethodNumberPane = new JPanel();
            divMethodNumberPane.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // WI{^
              divMethodNumberRbtn = new JRadioButton( "ŕ", false );
              divMethodNumberRbtn.addActionListener( this );
            divMethodNumberPane.add( divMethodNumberRbtn );
              divMethodNumberLbl = new JLabel( "" );
            divMethodNumberPane.add( divMethodNumberLbl );
              // ẅ
              divMethodNumber = new NumberField();
              divMethodNumber.setColumns( 10 );
            divMethodNumberPane.add( divMethodNumber );
          divMethodPane.add( divMethodNumberPane );
            // WI{^O[v
            divMethodRbgrp = new ButtonGroup();
            divMethodRbgrp.add( divMethodSizeRbtn );
            divMethodRbgrp.add( divMethodNumberRbtn );
        divPane.add( divMethodPane );
          // wyC
          divObjDirPane = new JPanel();
          divObjDirPane.setBorder( new TitledBorder( blackLine, "̏ꏊw", TitledBorder.LEFT, TitledBorder.TOP ) );
          divObjDirPane.setLayout( new BoxLayout( divObjDirPane, BoxLayout.Y_AXIS ) );
            // zup̉ByC
            divObjDirPane1 = new JPanel();
            divObjDirPane1.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // `FbN{bNX
              divObjDirCkbx = new JCheckBox( "̃t@Ct@CƓꏊɒu", true );
              divObjDirCkbx.addActionListener( this );
            divObjDirPane1.add( divObjDirCkbx );
          divObjDirPane.add( divObjDirPane1 );
            // zup̉ByC
            divObjDirPane2 = new JPanel();
            divObjDirPane2.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // fBNg̈
              divObjDirName = new JTextField();
              divObjDirName.setEditable( false ); // Cӓ͂Ȃ
              divObjDirName.setColumns( 30 );
            divObjDirPane2.add( divObjDirName );
              // Qƃ{^
              divObjDirBtn = new JButton( "Q" );
              divObjDirBtn.addActionListener( this ); // ANVo^
            divObjDirPane2.add( divObjDirBtn );
          divObjDirPane.add( divObjDirPane2 );
        divPane.add( divObjDirPane );
          // {^
          divBtn = new JButton( "s" );
          divBtn.addActionListener( this ); // ANVo^
        divPane.add( divBtn );
      // ȏ𕪊^uƂĒǉ
      tab.add( "", divPane );

        // yC
        conPane = new JPanel();
        conPane.setLayout( new BoxLayout( conPane, BoxLayout.Y_AXIS ) );
          // wt@CwyC
          conInfFilePane = new JPanel();
          conInfFilePane.setBorder( new TitledBorder( blackLine, "wt@C̎w", TitledBorder.LEFT, TitledBorder.TOP ) );
          conInfFilePane.setLayout( new FlowLayout( FlowLayout.LEFT ) );
            // t@C̈
            conInfFileName = new JTextField();
            conInfFileName.setEditable( false ); // Cӓ͂Ȃ
            conInfFileName.setColumns( 30 );
          conInfFilePane.add( conInfFileName );
            // Qƃ{^
            conInfFileBtn = new JButton( "Q" );
            conInfFileBtn.addActionListener( this ); // ANVo^
          conInfFilePane.add( conInfFileBtn );
        conPane.add( conInfFilePane );
          // t@C\yC
          conDispInfFilePane = new JPanel();
          conDispInfFilePane.setBorder( new TitledBorder( blackLine, "t@C̏", TitledBorder.LEFT, TitledBorder.TOP ) );
          conDispInfFilePane.setLayout( new BoxLayout( conDispInfFilePane, BoxLayout.Y_AXIS ) );
            // \peLXgGA
            conDispInfFileTxt = new JTextArea( 4, 26 );
            conDispInfFileTxt.setEditable( false ); // [UɂύXh
            conDispInfFileTxt.append( "t@CF\n" );
            conDispInfFileTxt.append( "t@CTCYF\n" );
            conDispInfFileTxt.append( "t@C CRCF\n" );
            conDispInfFileTxt.append( "t@CF\n" );
//          conDispInfFileTxt.setPreferredSize( null );
            conDispInfFileTxt.setSize( 340, 40 );
          conDispInfFilePane.add( conDispInfFileTxt );
            // et@C\pe[u
            conDispInfFileLbl = new JLabel( "et@Cɂ" );
          conDispInfFilePane.add( conDispInfFileLbl );
            conDispInfFileTblMdl = new MyTableModel( conDispInfFileValue, conDispInfFileColumn );
            conDispInfFileTbl = new JTable( conDispInfFileTblMdl );
            conDispInfFileTbl.setEnabled( false ); // [UɂύXh
              JScrollPane conDispInfFileTblSP = new JScrollPane( conDispInfFileTbl );
              conDispInfFileTblSP.setPreferredSize( null );
            TableColumn tblCol = conDispInfFileTbl.getColumnModel().getColumn( 0 ); // ԍ
            tblCol.setMaxWidth( 48 ); // 
            conDispInfFileTbl.setPreferredSize( null );
          conDispInfFilePane.add( conDispInfFileTblSP );
        conPane.add( conDispInfFilePane );
          // wyC
          conObjDirPane = new JPanel();
          conObjDirPane.setBorder( new TitledBorder( blackLine, "̏ꏊw", TitledBorder.LEFT, TitledBorder.TOP ) );
          conObjDirPane.setLayout( new BoxLayout( conObjDirPane, BoxLayout.Y_AXIS ) );
            // zup̉ByC
            conObjDirPane1 = new JPanel();
            conObjDirPane1.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // `FbN{bNX
              conObjDirCkbx = new JCheckBox( "̃t@C𕪊t@CƓꏊɒu", true );
              conObjDirCkbx.addActionListener( this );
            conObjDirPane1.add( conObjDirCkbx );
          conObjDirPane.add( conObjDirPane1 );
            // zup̉ByC
            conObjDirPane2 = new JPanel();
            conObjDirPane2.setLayout( new FlowLayout( FlowLayout.LEFT ) );
              // fBNg̈
              conObjDirName = new JTextField();
              conObjDirName.setEditable( false ); // Cӓ͂Ȃ
              conObjDirName.setColumns( 30 );
            conObjDirPane2.add( conObjDirName );
              // Qƃ{^
              conObjDirBtn = new JButton( "Q" );
              conObjDirBtn.addActionListener( this ); // ANVo^
            conObjDirPane2.add( conObjDirBtn );
          conObjDirPane.add( conObjDirPane2 );
        conPane.add( conObjDirPane );
          // {^
          conBtn = new JButton( "s" );
          conBtn.addActionListener( this ); // ANVo^
        conPane.add( conBtn );
      // ȏ^uƂĒǉ
      tab.add( "", conPane );

    // ȏ^uƂĒǉ
    this.add( tab, BorderLayout.CENTER );

      // [Xe[^Xo[yC
      sttBarPane = new JPanel();
      sttBarPane.setBorder( new BevelBorder( BevelBorder.LOWERED ) );
      sttBarPane.setLayout( new FlowLayout( FlowLayout.LEFT ) );
        sttBarLbl = new JLabel( "ԁF" );
      sttBarPane.add( sttBarLbl );
    // ȏXe[^Xo[ƂĒǉ
    this.add( sttBarPane, BorderLayout.SOUTH );

    // WbNAhtB[ɂďݒ
    menuDispEach = new ArrayList<JMenuItem>(); // j[ڂ
    defaultLF = UIManager.getSystemLookAndFeelClassName(); // sł̕WbNAhtB[擾
    try {
      // WbNAhtB[ݒ
      UIManager.setLookAndFeel( defaultLF );
      SwingUtilities.updateComponentTreeUI( this );
      // j[ڂݒ
      menuDispEach.add( new JMenuItem( "OS W̊O" ) );
      menuDispEach.get( 0 ).addActionListener( this ); // ANVo^
      menuDisp.add( menuDispEach.get( 0 ) );
    }
    catch ( Exception e ) {
      JOptionPane.showMessageDialog( this, "OS W̃bNAhtB[iOρjݒo܂ł", "G[", JOptionPane.ERROR_MESSAGE );
      return;
    }

    // ̑̃bNAhtB[ɂďݒ
    UIManager.LookAndFeelInfo[] LFInfo = UIManager.getInstalledLookAndFeels(); // gp\Ȉꗗ擾
    eachLF = new ArrayList<String>();
    for ( int i = 0; i < LFInfo.length; i ++ ) {
      // ebNAhtB[擾
      eachLF.add( new String( LFInfo[ i ].getClassName() ) );
      // j[ڂݒ
      menuDispEach.add( new JMenuItem( LFInfo[ i ].getName() ) );
      menuDispEach.get( i + 1 ).addActionListener( this ); // ANVo^
      menuDisp.add( menuDispEach.get( i + 1 ) );
    }

    // @\̏
    execDivFile = null; // s
    detectInfFile = null; // wt@C擾

    // vf̏
    srcFile = null; // t@C
    divObjDir = null; // fBNg
    infFile = null; // wt@C
    conObjDir = null; // fBNg

    // UI Ԃ̍XV
    this.updateGUIState();

    // 
    this.setVisible( true );
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @Xe[^Xo[Ɏw̕\B<p>
    @param s Xe[^Xo[ɕ\
  */
  public void setSttBar(
    String s
  ) {
    sttBarLbl.setText( "ԁF" + s );
    sttBarPane.paintImmediately( sttBarPane.getVisibleRect() ); // f
    return;
  }

  // -----------------------------------------------------------------------------------------------
  // }EXXi

  // #### Drop 

  /* ---------------------------------------------------------------------------------------- */ /**
    ANVXi<p>
    @param ae ANVCxg
  */
  public void actionPerformed(
    ActionEvent ae
  ) {
    StringBuffer sttBarSB;

    // j[
      // t@CI
      if ( ae.getSource() == menuFileExit ) {
        System.exit( 0 );
      }

      // \
        // OS W̊O
        if ( ae.getSource() == menuDispEach.get( 0 ) ) {
          try {
            UIManager.setLookAndFeel( defaultLF );
            SwingUtilities.updateComponentTreeUI( this );
          }
          catch ( Exception e ) {
            JOptionPane.showMessageDialog( this, "w̃bNAhtB[iOρjݒo܂ł", "G[", JOptionPane.ERROR_MESSAGE );
          }
        }
        // ȋj
        for ( int i = 1; i < menuDispEach.size(); i ++ ) {
          if ( ae.getSource() == menuDispEach.get( i ) ) {
            try {
              UIManager.setLookAndFeel( eachLF.get( i - 1 ) );
              SwingUtilities.updateComponentTreeUI( this );
            }
            catch ( Exception e ) {
              JOptionPane.showMessageDialog( this, "w̃bNAhtB[iOρjݒo܂ł", "G[", JOptionPane.ERROR_MESSAGE );
            }
          }
        }

      // wv
        // wv
        if ( ae.getSource() == menuHelpHelp ) {
          dispHelp = new DispHelp();
        }
        // o[W
        if ( ae.getSource() == menuHelpVer ) {
          JOptionPane.showMessageDialog( this, Common.MYNAME + " version " + Common.VERS + "\n" + Common.BUILD_DATE + "\nProgrammed by Ichiro Kurata" );
        }

    // ^u
      // t@CQƃ{^
      if ( ae.getSource() == divSrcFileBtn ) {
        JFileChooser divSrcFileChooser = new JFileChooser( divSrcFileName.getText() );
        divSrcFileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        int ret = divSrcFileChooser.showOpenDialog( this );
        if ( ret == JFileChooser.APPROVE_OPTION ) {
          srcFile = divSrcFileChooser.getSelectedFile();
          divSrcFileName.setText( srcFile.getAbsolutePath() );
          // Xe[^Xo[Ɍt@CTCY\
          sttBarSB = new StringBuffer( "t@CTCYF"  + srcFile.length() + " byte" );
          if ( srcFile.length() > 1024 * 1024 ) {
            sttBarSB.append( " ( " + ( srcFile.length() / ( 1024 * 1024 ) + 1 ) + " Mbyte)" );
          }
          else {
            if ( srcFile.length() > 1024 ) {
              sttBarSB.append( " ( " + ( srcFile.length() / 1024 + 1 ) + " Kbyte)" );
            }
          }
          setSttBar( sttBarSB.toString() );
        }
      }

      // TCYWI{^̃ANV͖

      // TCYPʑIR{{bNX̃ANV͖

      // WI{^̃ANV͖

      // t@CꏊI`FbN{bNX̃ANV͖

      // t@CꏊQƃ{^
      if ( ae.getSource() == divObjDirBtn ) {
        JFileChooser divObjDirChooser = new JFileChooser( divObjDirName.getText() );
        divObjDirChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int ret = divObjDirChooser.showOpenDialog( this );
        if ( ret == JFileChooser.APPROVE_OPTION ) {
          divObjDir = divObjDirChooser.getSelectedFile();
          String s = divObjDir.getAbsolutePath();
          if ( s.length() > 0 ) {
            divObjDirName.setText( s );
          }
          else {
            JOptionPane.showMessageDialog( this, "sȃfBNgI܂", "G[", JOptionPane.ERROR_MESSAGE );
            return;
          }
        }
      }

      // s{^
      if ( ae.getSource() == divBtn ) {
        // t@C
        if ( divSrcFileName.getText().length() < 1 ) {
          JOptionPane.showMessageDialog( this, "t@Cw肵Ă", "x", JOptionPane.WARNING_MESSAGE );
          return;
        }
        srcFile = new File( divSrcFileName.getText() );
        // ̏ꏊ
        String objDirFullPath;
        if ( divObjDirCkbx.isSelected() ) {
          divObjDir = new File( divSrcFileName.getText() );
        }
        else {
          if ( divObjDirName.getText().length() < 1 ) {
            JOptionPane.showMessageDialog( this, "̏ꏊw肳Ă܂", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          divObjDir = new File( divObjDirName.getText() );
        }
        // TCYw
        if ( divMethodSizeRbtn.isSelected() == true ) {
          // TCYZo
          if ( divMethodSize.getText().length() < 1 ) {
            JOptionPane.showMessageDialog( this, "TCYw肵Ă", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          long sz = Integer.parseInt( divMethodSize.getText() );
          if ( sz < 1 ) {
            JOptionPane.showMessageDialog( this, "TCY 0 ͎wo܂", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          // Kbyte
          if ( divMethodSizeUnit.getSelectedIndex() == 0 ) {
            sz = sz * 1024;
          }
          else {
            // Mbyte
            if ( divMethodSizeUnit.getSelectedIndex() == 1 ) {
              sz = sz * 1024 * 1024;
            }
            // Gbyte
            else {
              sz = sz * 1024 * 1024 * 1024;
            }
          }
          // s
          setSttBar( "" );
          execDivFile = new ExecDivFile( this, srcFile, true, sz, divObjDir );
        }
        // w
        else {
          if ( divMethodNumber.getText().length() < 1 ) {
            JOptionPane.showMessageDialog( this, "w肵Ă", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          long nm = Integer.parseInt( divMethodNumber.getText() );
          if ( nm < 2 ) {
            JOptionPane.showMessageDialog( this, " 0  1 ͎wo܂", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          if ( nm > srcFile.length() ) {
            JOptionPane.showMessageDialog( this, "t@C byte TCY𒴂͎wo܂", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          // s
          setSttBar( "" );
          execDivFile = new ExecDivFile( this, srcFile, false, nm, divObjDir );
        }
      }

    // ^u
      // wt@CQƃ{^
      if ( ae.getSource() == conInfFileBtn ) {
        JFileChooser conInfFileChooser = new JFileChooser( conInfFileName.getText() );
        conInfFileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
        // #### Ńt@CtB^ݒ肵A͑SẴt@CIo
        int ret = conInfFileChooser.showOpenDialog( this );
        if ( ret == JFileChooser.APPROVE_OPTION ) {
          infFile = conInfFileChooser.getSelectedFile();
          detectInfFile = new DetectInfFile( infFile );
          // wt@C̒ʂɂĂ͌x
          if ( detectInfFile.isUsable() == false || detectInfFile.getErrorCode() != DetectInfFile.ERR_NONE ) {
            JOptionPane.showMessageDialog( this, "wt@Cw肵Ă", "x", JOptionPane.WARNING_MESSAGE );
            return;
          }
          // t@CɂẴeLXg𖄂߂
          setDispInfFileTxt( detectInfFile.getSrcFileInf(), detectInfFile.getDivNumber() );
          // et@CɂĂ̕\𖄂߂
          setDispInfFileTbl( detectInfFile.getDivFileInfs() );
          // t@C\
          conInfFileName.setText( infFile.getAbsolutePath() );
          setSttBar( "" );
        }
      }

      // t@CꏊI`FbN{bNX̃ANV͖

      // t@CꏊQƃ{^
      if ( ae.getSource() == conObjDirBtn ) {
        JFileChooser conObjDirChooser = new JFileChooser( conObjDirName.getText() );
        conObjDirChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int ret = conObjDirChooser.showOpenDialog( this );
        if ( ret == JFileChooser.APPROVE_OPTION ) {
          conObjDir = conObjDirChooser.getSelectedFile();
          String s = conObjDir.getAbsolutePath();
          if ( s.length() > 0 ) {
            conObjDirName.setText( s );
          }
          else {
            JOptionPane.showMessageDialog( this, "sȃfBNgI܂", "G[", JOptionPane.ERROR_MESSAGE );
            return;
          }
        }
      }

      // s{^
      if ( ae.getSource() == conBtn ) {
        if ( detectInfFile == null ) {
          JOptionPane.showMessageDialog( this, "wt@CIĂ", "x", JOptionPane.WARNING_MESSAGE );
          return;
        }
        setSttBar( "" );
        if ( conObjDirCkbx.isSelected() ) {
          execConFile = new ExecConFile( this, infFile, infFile, detectInfFile );
        }
        else {
          execConFile = new ExecConFile( this, infFile, conObjDir, detectInfFile );
        }
      }

    // GUI XV
    this.updateGUIState();
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    GUI ԍXV<p>
  */
  public void updateGUIState(
  ) {

    // ^u
      // @wyC
        // TCYIĂAtB[h͕ύXsɂ
        if ( divMethodSizeRbtn.isSelected() == true ) {
          divMethodSize.setEditable( true );
          divMethodSizeUnit.setEnabled( true );
          divMethodNumber.setEditable( false );
        }
        // IĂATCYtB[hƃTCYPʃR{{bNX͕ύXsɂ
        if ( divMethodNumberRbtn.isSelected() == true ) {
          divMethodNumber.setEditable( true );
          divMethodSize.setEditable( false );
          divMethodSizeUnit.setEnabled( false );
        }

      // ̏ꏊwyC
        // `FbNĂAꏊtB[h͕ύXsɂ
        if ( divObjDirCkbx.isSelected() == true ) {
          divObjDirBtn.setEnabled( false );
        }
        else {
          divObjDirBtn.setEnabled( true );
        }

    // ^u
      // ̏ꏊwyC
        // `FbNĂAꏊtB[h͕ύXsɂ
        if ( conObjDirCkbx.isSelected() == true ) {
          conObjDirBtn.setEnabled( false );
        }
        else {
          conObjDirBtn.setEnabled( true );
        }

    this.repaint();

    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @t@C̏eLXgGA\B<p>
    @param fi   t@C
    @param divn t@C
  */
  private void setDispInfFileTxt(
    FileInf fi,
    long    divn
  ) {
    conDispInfFileTxt.setText( "" );
    conDispInfFileTxt.append( "t@CF" + fi.getName() + "\n" );
    conDispInfFileTxt.append( "t@CTCYF" + fi.getSize() + " byte" );
    if ( fi.getSize() > 1024 * 1024 ) {
      conDispInfFileTxt.append( " ( " + ( ( fi.getSize() / ( 1024 * 1024 ) ) + 1 ) + " Mbyte)" );
    }
    else {
      if ( fi.getSize() > 1024 ) {
        conDispInfFileTxt.append( " ( " + ( ( fi.getSize() / 1024 ) + 1 ) + " Kbyte)" );
      }
    }
    conDispInfFileTxt.append( "\n" );
    conDispInfFileTxt.append( "t@C CRCF" + Common.hex8FromLong( fi.getCrcValue() ) + " (16 i\)\n" );
    conDispInfFileTxt.append( "t@CF" + divn + " \n" );
    return;
  }

  /* ---------------------------------------------------------------------------------------- */ /**
    @et@C̏eLXge[u\B<p>
    @param dfis et@C
  */
  private void setDispInfFileTbl(
    ArrayList<FileInf> dfis
  ) {
    // ܂AɂsSď
    int rown = conDispInfFileTblMdl.getRowCount();
    for ( int i = 0; i < rown; i ++ ) {
      conDispInfFileTblMdl.removeRow( 0 ); // ɂOԖڂ폜ėǂ
    }
    // ɁAVsƂĒǉ
    int n = 1; // sԍ
    for ( FileInf fi:dfis ) {
      conDispInfFileTblMdl.addMyRow( n, " " + fi.getName(), fi.getSize(), "  " + Common.hex8FromLong( fi.getCrcValue() ) );
      n ++;
    }
    return;
  }

}
// =================================================================================================
// I
